<?php
/*
  $Id$

  Discount Code 5.4.2. Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Based on Discount Codes BS 3.x and 4.x by @Tsimi and @raiwa
  Based on the Discount Code for osCommerce 2.3.1 addon by high-quality-php-coding.com

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  $action = (isset($_GET['action']) ? $_GET['action'] : '');

  if (!Text::is_empty($action)) {
    switch ($action) {
      case 'setflag':
        tep_db_query(sprintf(<<<'EOSQL'
UPDATE discount_codes 
  SET status = %s 
  WHERE discount_codes_id = %s 
  LIMIT 1
EOSQL
        , (int)$_GET['flag'], (int)$_GET['dID']));

        tep_redirect(tep_href_link('discount_codes.php', 'page=' . $_GET['page']));
        break;
      case 'insert':
        if (!empty($_POST['discount_codes']) && !empty($_POST['discount_values'])) {
          $exclude_specials = isset($_POST['exclude_specials']) ? (int) $_POST['exclude_specials'] : 0;
          $sql_data_array = ['products_id' => '',
                             'categories_id' => '',
                             'manufacturers_id' => '',
                             'excluded_products_id' => '',
                             'customers_id' => '',
                             'orders_total' => '0',
                             'shipping' => '0',
                             'newsletter' => empty($_POST['newsletter']) ? 0 : (int)$_POST['newsletter'] ,
                             'order_number' => empty($_POST['order_number']) ? 0 : (int)$_POST['order_number'] ,
                             'order_info' => empty($_POST['order_info']) ? 0 : (int)$_POST['order_info'] ,
                             'exclude_specials' => $exclude_specials,
                             'discount_codes' => tep_db_prepare_input($_POST['discount_codes']),
                             'discount_description' => tep_db_prepare_input($_POST['discount_description']),
                             'discount_values' => tep_db_prepare_input($_POST['discount_values']),
                             'minimum_order_amount' => tep_db_prepare_input($_POST['minimum_order_amount']),
                             'expires_date' => empty($_POST['expires_date']) ? '0000-00-00' : tep_db_prepare_input($_POST['expires_date']),
                             'number_of_use' => (int)$_POST['number_of_use'],
                             'number_of_products' => 0];

          $error = true;
          if ((int)$_POST['applies_to'] == 1) {
            if (isset($_POST['products_id']) && is_array($_POST['products_id']) && sizeof($_POST['products_id']) > 0) {
              $sql_data_array['products_id'] = implode(',', $_POST['products_id']);
              $error = false;
            }
          } elseif ((int)$_POST['applies_to'] == 2) {
            if (isset($_POST['categories_id']) && is_array($_POST['categories_id']) && sizeof($_POST['categories_id']) > 0) {
              $sql_data_array['categories_id'] = implode(',', $_POST['categories_id']);
              $error = false;
            }
          } elseif ((int)$_POST['applies_to'] == 3) {
            $sql_data_array['orders_total'] = 1; // total
            $error = false;
          } elseif ((int)$_POST['applies_to'] == 4) {
            if (isset($_POST['manufacturers_id']) && is_array($_POST['manufacturers_id']) && sizeof($_POST['manufacturers_id']) > 0) {
              $sql_data_array['manufacturers_id'] = implode(',', $_POST['manufacturers_id']);
              $error = false;
            }
          } elseif ((int)$_POST['applies_to'] == 5) {
            $sql_data_array['orders_total'] = 2; // subtotal
            $error = false;
          } elseif ((int)$_POST['applies_to'] == 6) {
            $sql_data_array['shipping'] = 2; // shipping
            $error = false;
		  }

          if ((int)$_POST['applies_to'] == 2 || (int)$_POST['applies_to'] == 4) {
            if (isset($_POST['excluded_products_id']) && is_array($_POST['excluded_products_id']) && sizeof($_POST['excluded_products_id']) > 0) {
              $sql_data_array['excluded_products_id'] = implode(',', $_POST['excluded_products_id']);
            }
          }

          if ((int)$_POST['applies_to'] != 3 && !empty($_POST['number_of_products'])) {
            $sql_data_array['number_of_products'] = (int)$_POST['number_of_products'];
          }

          if (!empty($_POST['customers']) && $_POST['customers'] == 1) {
            if (is_array($_POST['customers_id']) && sizeof($_POST['customers_id']) > 0) {
              $sql_data_array['customers_id'] = implode(',', $_POST['customers_id']);
            }
          }

          if (!empty($_POST['newsletter']) && $_POST['newsletter'] == 1) {
            $sql_data_array['newsletter'] = (int)$_POST['newsletter'];
          }

          if (!empty($_POST['order_number']) && $_POST['order_number'] > 0) {
            $sql_data_array['order_number'] = (int)$_POST['order_number'];
          }

          if ($error == false) {
            if (empty($_GET['dID'])) {
              tep_db_perform('discount_codes', $sql_data_array);
              $messageStack->add_session(SUCCESS_DISCOUNT_CODE_INSERTED, 'success');
            } else {
              tep_db_perform('discount_codes', $sql_data_array, 'update', "discount_codes_id = '" . (int)$_GET['dID'] . "'");
              $messageStack->add_session(SUCCESS_DISCOUNT_CODE_UPDATED, 'success');
            }
            tep_redirect(tep_href_link('discount_codes.php'));
          }
        }
        $action = 'new';
        break;
      case 'deleteconfirm':
        tep_db_query(sprintf(<<<'EOSQL'
DELETE 
  FROM customers_to_discount_codes 
  WHERE discount_codes_id = %s
EOSQL
        , (int)$_GET['dID']));

        tep_db_query(sprintf(<<<'EOSQL'
DELETE 
  FROM discount_codes 
  WHERE discount_codes_id = %s 
  LIMIT 1
EOSQL
        , (int)$_GET['dID']));

        $messageStack->add_session(SUCCESS_DISCOUNT_CODE_REMOVED, 'success');

        tep_redirect(tep_href_link('discount_codes.php', 'page=' . $_GET['page']));
        break;
    }
  }

  $currencies = new currencies();

  require('includes/template_top.php');

?>
  <div class="row">
    <div class="col">
      <h1 class="display-4 mb-2"><?= HEADING_TITLE ?></h1>
      <?php
      if ( !defined('MODULE_ORDER_TOTAL_DISCOUNT_STATUS') ) {
        echo '<div class="alert alert-warning">';
        printf(WARNING_OT_MODULE_INSTALL, tep_href_link('modules.php?set=order_total&module=ot_discount&action=install'));
        echo '</div>';
      } elseif ( MODULE_ORDER_TOTAL_DISCOUNT_STATUS != 'True' ) {
        echo '<div class="alert alert-warning">';
        printf(WARNING_OT_MODULE_SWITCH, tep_href_link('modules.php?set=order_total&module=ot_discount&action=edit'));
        echo '</div>';
      }
      ?>
    </div>
    <div class="col text-right align-self-center">
      <?php
      if (empty($action)) {
        echo tep_draw_bootstrap_button(BUTTON_INSERT_NEW_DISCOUNT_CODE, 'fas fa-tag', tep_href_link('discount_codes.php', 'action=new'), null, null, 'btn-danger xxx text-white');
      } else {
        echo tep_draw_bootstrap_button(IMAGE_CANCEL, 'fas fa-angle-left', tep_href_link('discount_codes.php'), null, null, 'btn-light mt-2');
      }
      ?>
    </div>
  </div>

<?php
  if ('new' === $action) {

    echo tep_draw_form('new_discount_code', 'discount_codes.php', (isset($_GET['page']) ? 'page=' . $_GET['page'] . '&' : '') . 'action=insert' . (isset($_GET['dID']) ? '&dID=' . (int)$_GET['dID'] : ''));

    $dInfo = new objectInfo(['products_id' => '',
                             'categories_id' => '',
                             'manufacturers_id' => '',
                             'excluded_products_id' => '',
                             'customers_id' => '',
                             'orders_total' => '2',
                             'shipping' => '',
                             'newsletter' => '',
                             'order_number' => '',
                             'order_info' => '',
                             'exclude_specials' => '',
                             'discount_codes' => substr(md5(uniqid(rand(), true)), 0, 8),
                             'discount_description' => '',
                             'discount_values' => '',
                             'minimum_order_amount' => '',
                             'expires_date' => '',
                             'number_of_orders' => '',
                             'number_of_use' => '1',
                             'number_of_products' => '1',
                             'status' => '']);

    if (isset($_GET['dID'])) {
      $discount_code_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT * 
  FROM discount_codes 
  WHERE discount_codes_id = %s
EOSQL
        , (int)$_GET['dID']));

      $discount_code = $discount_code_query->fetch_assoc();

      $dInfo->objectInfo($discount_code);

      if (!empty($discount_code['products_id'])) $dInfo->products_id = explode(',', $discount_code['products_id']);
      if (!empty($discount_code['categories_id'])) $dInfo->categories_id = explode(',', $discount_code['categories_id']);
      if (!empty($discount_code['manufacturers_id'])) $dInfo->manufacturers_id = explode(',', $discount_code['manufacturers_id']);
      if (!empty($discount_code['excluded_products_id'])) $dInfo->excluded_products_id = explode(',', $discount_code['excluded_products_id']);
      if (!empty($discount_code['customers_id'])) $dInfo->customers_id = explode(',', $discount_code['customers_id']);
      if ($discount_code['minimum_order_amount'] == '0.0000') $dInfo->minimum_order_amount = '';
      if ($discount_code['expires_date'] == '0000-00-00') $dInfo->expires_date = '';
      if ($discount_code['number_of_use'] == 0) $dInfo->number_of_use = '';
      if ($discount_code['number_of_products'] == 0) $dInfo->number_of_products = '';
    }

    $manufacturers_array = [];
    $manufacturers_query = tep_db_query(<<<'EOSQL'
SELECT manufacturers_id, manufacturers_name 
  FROM manufacturers 
  ORDER by manufacturers_name
EOSQL
    );

    while ( $manufacturers = $manufacturers_query->fetch_assoc() ) {
      $manufacturers_array[] = ['id' => $manufacturers['manufacturers_id'],
                                'text' => $manufacturers['manufacturers_name']];
    }
?>

    <div class="alert alert-info">
      <?= TEXT_DISCOUNT_EXPL ?>
    </div>

    <div class="form-group row">
      <label for="discount_description" class="col-form-label col-sm-3 text-left text-sm-right pt-0"><?= TEXT_DISCOUNT_DESCRIPTION ?></label>
      <div class="col-sm-9"><?= tep_draw_input_field('discount_description', $dInfo->discount_description, null, true) ?>
      </div>
    </div>

    <div class="row">
      <div class="col-sm-6">
        <div class="form-group row">
          <label for="discount_codes" class="col-form-label col-sm-6 text-left text-sm-right"><?= TEXT_DISCOUNT_CODE ?></label>
          <div class="col-sm-6"><?= tep_draw_input_field('discount_codes', $dInfo->discount_codes, 'style="width: 150px;"', true) ?>
          </div>
        </div>
        <div class="form-group row">
          <label for="discount_values" class="col-form-label col-sm-6 text-left text-sm-right"><?= TEXT_DISCOUNT ?></label>
          <div class="col-sm-6"><?= tep_draw_input_field('discount_values', $dInfo->discount_values, 'style="width: 150px;"', true) ?>
          </div>
        </div>
        <div class="form-group row">
          <label for="minimum_order_amount" class="col-form-label col-sm-6 text-left text-sm-right"><?= TEXT_MINIMUM_ORDER_SUB_TOTAL ?></label>
          <div class="col-sm-6"><?= tep_draw_input_field('minimum_order_amount', $dInfo->minimum_order_amount, 'style="width: 150px;"', true) ?>
          </div>
        </div>
        <div class="form-group row">
          <label for="expires_date" class="col-form-label col-sm-6 text-left text-sm-right pt-0"><?= TEXT_EXPIRY ?></label>
          <div class="col-sm-6"><?= tep_draw_input_field('expires_date', $dInfo->expires_date, 'id="expires_date" style="width: 150px;"', true) ?>
          </div>
        </div>
      </div>

      <div class="col-sm-6">
        <div class="form-group row">
          <label for="number_of_use" class="col-form-label col-sm-6 text-left text-sm-right py-0"><?= TEXT_NUMBER_OF_USE ?></label>
          <div class="col-sm-6"><?= tep_draw_input_field('number_of_use', $dInfo->number_of_use, 'style="width: 50px;"', true) ?>
          </div>
        </div>
        <div class="form-group row">
          <label for="number_of_products" class="col-form-label col-sm-6 text-left text-sm-right py-0"><?= TEXT_NUMBER_OF_PRODUCTS ?></label>
          <div class="col-sm-6"><?= tep_draw_input_field('number_of_products', $dInfo->number_of_products, 'id="number_of_products" style="width: 50px;"', true) ?>
          </div>
        </div>
        <div class="form-group row">
          <label for="order_number" class="col-form-label col-sm-6 text-left text-sm-right py-0"><?= TEXT_ORDER_CUSTOMERS ?></label>
          <div class="col-sm-6"><?= tep_draw_input_field('order_number', $dInfo->order_number, 'style="width: 50px;"', true) ?>
          </div>
        </div>
        <div class="form-group row align-items-center my-0">
          <div class="col-form-label col-sm-6 text-left text-sm-right"><?= TEXT_ORDER_INFO ?></div>
          <div class="col-sm-6 pl-5 custom-control custom-switch">
            <?= tep_draw_selection_field('order_info', 'checkbox', '1', $dInfo->order_info == 1, 'class="custom-control-input" id="order_info"') ?>
            <label for="order_info" class="custom-control-label text-muted"><small><?= TEXT_ORDER_INFO_INCLUDE ?>&nbsp;</small></label>
          </div>
        </div>
        <div class="form-group row align-items-center my-0">
          <div class="col-form-label col-sm-6 text-left text-sm-right"><?= TEXT_NEWSLETTER_CUSTOMERS ?></div>
          <div class="col-sm-6 pl-5 custom-control custom-switch">
            <?= tep_draw_selection_field('newsletter', 'checkbox', '1', is_array($dInfo->customers_id), 'class="custom-control-input" id="newsletter"'); ?>
            <label for="newsletter" class="custom-control-label text-muted"><small><?= TEXT_NEWSLETTER_ONLY; ?>&nbsp;</small></label>
          </div>
        </div>
        <div class="form-group row align-items-center">
          <div class="col-form-label col-sm-6 text-left text-sm-right"><?= TEXT_SPECIALS; ?></div>
          <div class="col-sm-6 pl-5 custom-control custom-switch">
            <?= tep_draw_selection_field('exclude_specials', 'checkbox', 1, $dInfo->exclude_specials, 'class="custom-control-input" id="exclude_specials"') ?>
            <label for="exclude_specials" class="custom-control-label text-muted"><small><?= TEXT_EXCLUDE_SPECIALS ?>&nbsp;</small></label>
          </div>
        </div>
      </div>
    </div>

    <div class="row mt-3">
      <div class="col-sm-4">
      <?= TEXT_APPLIES_TO; ?>
      </div>
      <div class="col-sm-4">
        <?= '<label>' . str_replace('<input type="radio"', '<input onclick="applies_to_onclick();" type="radio"', tep_draw_radio_field('applies_to', '5', $dInfo->orders_total == 2)) . '&nbsp;' . TEXT_ORDER_SUBTOTAL . '</label>' ?>
      </div>
      <div class="col-sm-4">
         <?= '<label>' . str_replace('<input type="radio"', '<input onclick="applies_to_onclick();" type="radio"', tep_draw_radio_field('applies_to', '6', $dInfo->shipping == 2)) . '&nbsp;' . TEXT_SHIPPING . '</label>' ?>
      </div>
    </div>

    <div class="row">
      <div class="col-sm-4">
        <?= '<label>' . str_replace('<input type="radio"', '<input onclick="applies_to_onclick();" type="radio"', tep_draw_radio_field('applies_to', '1', is_array($dInfo->products_id))) . '&nbsp;' . TEXT_PRODUCTS . '</label>' ?>

        <?php
        $products_id = '';
        $products_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT p.products_id, pd.products_name, p.products_price, s.specials_new_products_price 
  FROM (products p, products_description pd) 
    LEFT JOIN specials s ON (p.products_id = s.products_id 
      AND s.status = '1' 
      AND ifnull(s.expires_date, now()) >= now()) 
  WHERE p.products_id = pd.products_id 
    AND pd.language_id = %s 
  ORDER BY products_name
EOSQL
        , (int)$_SESSION['languages_id']));

        while ( $products = $products_query->fetch_assoc() ) {
          $products_id .= '<option value="' . $products['products_id'] . '">' . $products['products_name'] . ' (' . (empty($products['specials_new_products_price']) ? '' : $currencies->format($products['specials_new_products_price']) . '/') . $currencies->format($products['products_price']) . ')</option>';
        }
        $products_id .= '</select>';

        $excluded_products_id = '<select name="excluded_products_id[]" class="form-control" size="10" multiple style="width: 280px;" id="excluded_products_id"  disabled>' . $products_id;
        $products_id = '<select name="products_id[]" class="form-control" size="10" multiple style="width: 280px;">' . $products_id;

        if (is_array($dInfo->products_id)) {
          foreach ($dInfo->products_id as $v) {
            $products_id = str_replace('<option value="' . $v . '">', '<option value="' . $v . '" selected>', $products_id);
          }
        }

        if (is_array($dInfo->excluded_products_id)) {
          foreach ($dInfo->excluded_products_id as $v) {
            $excluded_products_id = str_replace('<option value="' . $v . '">', '<option value="' . $v . '" selected>', $excluded_products_id);
          }
        }
        ?>
        <div class="form-group">
          <?= $products_id ?>
        </div>

        <p class="mt-4 mb-2"><?= TEXT_EXCLUDED_PRODUCTS ?></p>
        <div class="form-group">
          <?= $excluded_products_id ?>
        </div>


      </div>
      <div class="col-sm-4">
      <?php
        $categories_id = str_replace('<select name="categories_id" class="form-control">', '<select name="categories_id[]" class="form-control" size="10" multiple style="width: 280px;">', tep_draw_pull_down_menu('categories_id', tep_get_category_tree('0', '', '0')));
        if (is_array($dInfo->categories_id)) {
          foreach ($dInfo->categories_id as $v) {
            $categories_id = str_replace('<option value="' . $v . '">', '<option value="' . $v . '" selected>', $categories_id);
          }
        }
      ?>
      <?= '<label>' . str_replace('<input type="radio"', '<input onclick="applies_to_onclick();" type="radio"', tep_draw_radio_field('applies_to', '2', is_array($dInfo->categories_id))) . '&nbsp;' . TEXT_CATEGORIES . '</label>'; ?>
      <div class="form-group">
        <?= $categories_id ?>
      </div>

      <?php
        $customers_id = '<select name="customers_id[]" class="form-control" size="10" multiple style="width: 280px;" id="customers_id" disabled>';
        $customers_query = tep_db_query(<<<'EOSQL'
SELECT customers_id, concat(customers_lastname, ', ', customers_firstname, ' (', customers_email_address, ')') AS customers_info 
  FROM customers 
ORDER BY customers_lastname, customers_firstname
EOSQL
        );

        while ( $customers = $customers_query->fetch_assoc() ) {
          $customers_id .= '<option value="' . $customers['customers_id'] . '">' . $customers['customers_info'] . '</option>';
        }
        $customers_id .= '</select>';

        if (is_array($dInfo->customers_id)) {
          foreach ($dInfo->customers_id as $v) {
            $customers_id = str_replace('<option value="' . $v . '">', '<option value="' . $v . '" selected>', $customers_id);
          }
        }
        ?>
        <div class="form-group row align-items-center mb-0">
          <div class="col-form-label col-4"><?= TEXT_CUSTOMERS ?></div>
          <div class="col-sm-8 custom-control custom-switch">
            <?= tep_draw_selection_field('customers', 'checkbox', '1', is_array($dInfo->customers_id), 'class="custom-control-input" id="customers" onchange="customers_onclick();"') ?>
            <label for="customers" class="custom-control-label text-muted"><small><?= TEXT_CUSTOMERS_SELECT ?>&nbsp;</small></label>
          </div>
        </div>
        <div class="form-group">
          <?= $customers_id; ?>
        </div>
      </div>

      <div class="col-sm-4">
        <?= '<label>' . str_replace('<input type="radio"', '<input onclick="applies_to_onclick();" type="radio"', tep_draw_radio_field('applies_to', '4', is_array($dInfo->manufacturers_id))) . '&nbsp;' . TEXT_MANUFACTURERS . '</label>' ?>
        <?php
          $manufacturers_id = str_replace('<select name="manufacturers_id" class="form-control">', '<select name="manufacturers_id[]" class="form-control" size="10" multiple style="width: 280px;">', tep_draw_pull_down_menu('manufacturers_id', $manufacturers_array));
          if (is_array($dInfo->manufacturers_id)) {
            foreach ($dInfo->manufacturers_id as $v) {
              $manufacturers_id = str_replace('<option value="' . $v . '">', '<option value="' . $v . '" selected>', $manufacturers_id);
            }
          }
          $manufacturers_id .= '</select>';
        ?>
        <div class="form-group">
          <?= $manufacturers_id ?>
        </div>
      </div>
    </div>

    <?= tep_draw_bootstrap_button(IMAGE_SAVE, 'fas fa-save', null, 'primary', null, 'btn-success btn-block btn-lg') ?>
  </form>

<script>
$(document).ready(function() {
    if (<?= ((basename($PHP_SELF) == 'discount_codes.php' && isset($action) && $action == 'new') ? 'true' : 'false')?>) {
        onload();
    }
});
function applies_to_onclick() {
  var a = document.new_discount_code.applies_to, b = document.getElementById("excluded_products_id"), c = document.getElementById("number_of_products"), d = document.getElementById("exclude_specials");
  for (var ﻿i = 0, n = a.length; i < n; i++) if (a[i].checked) { b.disabled = (a[i].value == 2 || a[i].value == 4 ? false : true); c.disabled = (a[i].value == 3 || a[i].value == 5 || a[i].value == 6 ? true : false); d.disabled = (a[i].value == 3 || a[i].value == 6 ? true : false) }
  }
function customers_onclick() {
  var d = document.getElementById("customers"), e = document.getElementById("customers_id"); e.disabled = !d.checked;
}
function onload() {
  applies_to_onclick();
  customers_onclick();
}
$('#expires_date').datepicker({
  dateFormat: 'yy-mm-dd'
});
</script>

<?php
  } else {
?>
  <div class="row no-gutters">
    <div class="col">
      <div class="table-responsive">
        <table class="table table-striped table-hover">
          <thead class="thead-dark">
            <tr>
              <th><?= TABLE_HEADING_DISCOUNT_CODE ?></th>
              <th><?= TABLE_HEADING_DESCRIPTION ?></td>
              <th><?= TABLE_HEADING_APPLIES_TO ?></th>
              <th class="text-center"><?= TABLE_HEADING_DISCOUNT ?></th>
              <th class="text-center"><?= TABLE_HEADING_EXPIRY ?></th>
              <th class="text-right"><?= TABLE_HEADING_STATUS ?></th>
              <th class="text-right"><?= TABLE_HEADING_ACTION ?>&nbsp;</th>
              </tr>
          </thead>
          <tbody>
          <?php
            $discount_codes_query_raw = "SELECT * 
                                           FROM discount_codes 
                                         ORDER BY discount_codes_id DESC";
            $discount_codes_split = new splitPageResults($_GET['page'], MAX_DISPLAY_SEARCH_RESULTS, $discount_codes_query_raw, $discount_codes_query_numrows);
            $discount_codes_query = tep_db_query($discount_codes_query_raw);
            while ( $discount_codes = $discount_codes_query->fetch_assoc() ) {
              $applies_to = '';
              if (!empty($discount_codes['orders_total'])) {
                if ($discount_codes['orders_total'] == 2) {
                  $applies_to = TEXT_ORDER_SUBTOTAL;
                }
              } elseif (!empty($discount_codes['shipping'])) {
                if ($discount_codes['shipping'] == 2) {
                  $applies_to = TEXT_SHIPPING;
                }
              } elseif (!empty($discount_codes['products_id'])) {
                $applies_to = TEXT_PRODUCTS;
                $product_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT products_name 
  FROM products_description 
  WHERE products_id IN (%s) 
    AND language_id = %s 
  ORDER BY products_name 
EOSQL
                , $discount_codes['products_id'], (int)$_SESSION['languages_id']));

                while ( $product = $product_query->fetch_assoc() ) {
                  $applies_to .= (empty($applies_to) ? '' : '<br>') . $product['products_name'];
                }
              } elseif (!empty($discount_codes['categories_id'])) {
                $applies_to = TEXT_CATEGORIES;
                $category_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT c.categories_id FROM categories c, categories_description cd 
  WHERE c.categories_id = cd.categories_id 
    AND cd.language_id = %s 
    AND c.categories_id in (%s) 
  ORDER BY c.parent_id, cd.categories_name
EOSQL
                , (int)$_SESSION['languages_id'], $discount_codes['categories_id']));

                while ( $category = $category_query->fetch_assoc() ) {
                  $applies_to .= (empty($applies_to) ? '' : '<br>') . tep_output_generated_category_path($category['categories_id']);
                }
              } else {
                $applies_to = TEXT_MANUFACTURERS;
                $manufacturer_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT manufacturers_name 
  FROM manufacturers 
  WHERE manufacturers_id IN (%s) 
  ORDER BY manufacturers_name
EOSQL
                , $discount_codes['manufacturers_id']));

                while ( $manufacturer = $manufacturer_query->fetch_assoc() ) {
                  $applies_to .= (empty($applies_to) ? '' : '<br>') . $manufacturer['manufacturers_name'];
                }
              }
              if (!empty($discount_codes['excluded_products_id'])) {
                $applies_to .= '<br>' . TEXT_EXCLUDED_PRODUCTS;
                $product_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT products_name 
  FROM products_description 
  WHERE products_id IN (%s) 
    AND language_id = %s 
  ORDER BY products_name
EOSQL
                , $discount_codes['excluded_products_id'], (int)$_SESSION['languages_id']));

                while ( $product = $product_query->fetch_assoc() ) {
                  $applies_to .= (empty($applies_to) ? '' : '<br>') . $product['products_name'];
                }
              }

              if ((!isset($_GET['dID']) || (isset($_GET['dID']) && ($_GET['dID'] == $discount_codes['discount_codes_id']))) && !isset($dInfo) && (substr($action, 0, 3) != 'new')) {
                $dInfo = new objectInfo($discount_codes);
              }

              if (isset($dInfo) && is_object($dInfo) && ($discount_codes['discount_codes_id'] == $dInfo->discount_codes_id)) {
                echo '<tr class="table-active" onclick="document.location.href=\'' . tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $dInfo->discount_codes_id) . '\'">';
              } else {
                echo '<tr onclick="document.location.href=\'' . tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $discount_codes['discount_codes_id']) . '\'">';
              }
              ?>
                <td class="dataTableContent"><?= $discount_codes['discount_codes'] ?></td>
                <td class="dataTableContent"><?= $discount_codes['discount_description'] ?></td>
                <td class="dataTableContent"><?= $applies_to ?></td>
                <td class="dataTableContent" align="center">
                <?php
                switch ($discount_codes['discount_values']) {
                case strpos($discount_codes['discount_values'], '%') == true:
                          $discount_codes_value = $discount_codes['discount_values'];
                          break;
                      default:
                        $discount_codes_value = $currencies->format($discount_codes['discount_values']);
                    }
                echo $discount_codes_value;
                ?>
                </td>
                <td class="dataTableContent" align="center"><?= $discount_codes['expires_date'] == '0000-00-00' ? '-' : tep_date_short($discount_codes['expires_date']) ?>&nbsp;</td>
                <td class="dataTableContent" align="right">
                  <?php
                  if ($discount_codes['status'] == '1') {
                    echo '<i class="fas fa-check-circle text-success"></i> <a href="' . tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $discount_codes['discount_codes_id'] . '&action=setflag&flag=0') . '"><i class="fas fa-times-circle text-muted"></i></a>';
                  } else {
                    echo '<a href="' . tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $discount_codes['discount_codes_id'] . '&action=setflag&flag=1') . '"><i class="fas fa-check-circle text-muted"></i></a>  <i class="fas fa-times-circle text-danger"></i>';
                  }
                  ?>
                </td>
                <td class="dataTableContent" align="right"><?php if (isset($dInfo) && is_object($dInfo) && ($discount_codes['discount_codes_id'] == $dInfo->discount_codes_id)) { echo '<a href="' . tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $discount_codes['discount_codes_id'] . '&action=new') . '"><i class="fas fa-chevron-circle-right text-info"></i></a>';  } else {  echo '<i class="fas fa-info-circle text-muted">'; } ?>&nbsp;</td>
             </tr>
            <?php
            }
            ?>
          </tbody>
        </table>
      </div>

      <div class="row my-1">
        <div class="col"><?= $discount_codes_split->display_count($discount_codes_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, $_GET['page'], TEXT_DISPLAY_NUMBER_OF_DISCOUNT_CODES) ?></div>
        <div class="col text-right mr-2"><?= $discount_codes_split->display_links($discount_codes_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, MAX_DISPLAY_PAGE_LINKS, $_GET['page']) ?></div>
      </div>
    </div>

<?php
  $heading = [];
  $contents = [];

  $col = 6;
  switch ($action) {
    case 'delete':
      $col = 3;
      $heading[] = ['text' => '<strong>' . $dInfo->discount_codes . '</strong>'];

      $contents = ['form' => tep_draw_form('discount_codes', 'discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $dInfo->discount_codes_id . '&action=deleteconfirm')];
      $contents[] = ['text' => TEXT_INFO_DELETE_INTRO];
      $contents[] = ['class' => 'text-center', 'text' => tep_draw_bootstrap_button(IMAGE_DELETE, 'fas fa-trash', null, 'primary', null, 'btn-danger xxx text-white mr-2') . tep_draw_bootstrap_button(IMAGE_CANCEL, 'fas fa-times', tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $_GET['dID']), null, null, 'btn-light')];
      break;
    default:
      $col = 3;
      if ( isset($dInfo) && is_object($dInfo) ) {
        $heading[] = ['text' => '<strong>' . $dInfo->discount_codes . '</strong>'];

        $contents[] = ['class' => 'text-center', 'text' => tep_draw_bootstrap_button(IMAGE_EDIT, 'fas fa-cogs', tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $dInfo->discount_codes_id . '&action=new'), null, null, 'btn-warning mr-2') . tep_draw_bootstrap_button(IMAGE_DELETE, 'fas fa-trash', tep_href_link('discount_codes.php', 'page=' . $_GET['page'] . '&dID=' . $dInfo->discount_codes_id . '&action=delete'), null, null, 'btn-danger xxx text-white')];
        $contents[] = ['text' => '<br>'];
        $contents[] = ['text' => TABLE_HEADING_NUMBER_OF_ORDERS_FULL . ':&nbsp;' . $dInfo->number_of_orders];
        if ($dInfo->minimum_order_amount > 0) $contents[] = ['text' => TABLE_HEADING_MINIMUM_ORDER_AMOUNT_FULL . ':&nbsp;' . $currencies->format($dInfo->minimum_order_amount)];
        if ($dInfo->exclude_specials == 1) $contents[] = ['text' => tep_image('images/icons/tick.gif', TEXT_EXCLUDE_SPECIALS) . '&nbsp;' . TEXT_EXCLUDE_SPECIALS];
        if ($dInfo->newsletter == 1) $contents[] = ['text' => tep_image('images/icons/tick.gif', TEXT_NEWSLETTER) . '&nbsp;' . TEXT_NEWSLETTER];
        if ($dInfo->order_number > 0) $contents[] = ['text' => tep_image('images/icons/tick.gif', TEXT_ORDER_NUMBER) . '&nbsp;' . TEXT_ORDER_NUMBER . $dInfo->order_number];
        if ($dInfo->number_of_use != 0) $contents[] = ['text' => TABLE_HEADING_NUMBER_OF_USE . ' ' . $dInfo->number_of_use];
        if ($dInfo->number_of_products != 0) $contents[] = ['text' => TABLE_HEADING_NUMBER_OF_PRODUCTS . ' ' . $dInfo->number_of_products];
        if (!empty($dInfo->customers_id)) {
          $select_string = '';
          $customers_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT concat(customers_lastname, ', ', customers_firstname, ' (', customers_email_address, ')') AS customers_info 
  FROM customers 
  WHERE customers_id in (%s) 
ORDER BY customers_lastname, customers_firstname
EOSQL
          , (int)$dInfo->customers_id));

          while ( $customers = $customers_query->fetch_assoc() ) {
            $select_string .= (empty($select_string) ? '' : '<br>') . $customers['customers_info'];
          }
          if (!empty($select_string)) {
            $contents[] = ['text' => '<br>' . TEXT_INFO_CUSTOMERS . '<br>' . $select_string];
          }
        }
      }
      break;
  }

  if ( ([] !== $heading) && ([] !== $contents) ) {
    echo '<div class="col-12 col-sm-4">';
      $box = new box();
      echo $box->infoBox($heading, $contents);
    echo '</div>';
  }
?>
  </div>
<?php
  }

  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
